/*
 *  Copyright 2002-2004, Mersad Team, Allame Helli High School (NODET).
 *
 *  This program is free software, you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU Library General Public License for more details.
 *
 *  Created by: Meisam Vosoughpour
 *  Released on Friday 1 April 2005 by Mersad RoboCup Team.
 *  For more information please read README file.
*/

#ifndef __BLOCK_H
#define __BLOCK_H

#include <AdvancedAction.h>
#include <Positioning.h>

class Block: public AdvancedAction
{
protected:
	InterceptCalculate blockInterCalc;
	const Positioning &positioning;
	DecideType lastDecide;
	Point blockPoint;
	Command *blockCommand;
		
public:
	Block(const WorldModel *worldModel,
		const Positioning &positioning);
	
	void giveLastDecide(DecideType lastDecideArg);

	virtual ~Block();
	
	virtual void execute(SayDecisionFlags &sayFlags);
	virtual float getValue();
	virtual DecideType getType();
};

#endif // __BLOCK_H
