/*
 *  Copyright 2002-2004, Mersad Team, Allame Helli High School (NODET).
 *
 *  This program is free software, you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU Library General Public License for more details.
 *
 *  Created by: Meisam Vosoughpour
 *  Released on Friday 1 April 2005 by Mersad RoboCup Team.
 *  For more information please read README file.
*/

#ifndef __GOALIE_INTERCEPT_H
#define __GOALIE_INTERCEPT_H


#include <AdvancedAction.h>


#define GOALIE_WAIT_FOR_BALL_CYCLES 3
#define GOALIE_MAX_POSITIVE_DASH_CYCLES 200
#define GOALIE_MAX_NEGATIVE_DASH_CYCLES 200
#define GOALIE_MAX_GTB_POINTS_NUM 100
#define GOALIE_MAX_GTB_CHECKED_TIME 300


class GoalieCatch: public AdvancedAction
{
protected:
	bool catchableFlag;
	DecideType lastDecide;
public:
	GoalieCatch(const WorldModel *worldModel);

	virtual void execute(SayDecisionFlags &sayFlags);
	virtual float getValue();
	virtual DecideType getType();
	void giveLastDecide(DecideType lastDecideArg);
};

class GoalieIntercept: public AdvancedAction
{
	int bestGTBPointNumber;
	int gtbPointsNumber;
	float gtbTime[GOALIE_MAX_GTB_POINTS_NUM];
	float minBallDistance[GOALIE_MAX_GTB_POINTS_NUM];
	float extraGTBTime[GOALIE_MAX_GTB_POINTS_NUM];
	float distToBegin[GOALIE_MAX_GTB_POINTS_NUM];
	float gtbPointWeight[GOALIE_MAX_GTB_POINTS_NUM];
	Point gtbPoint[GOALIE_MAX_GTB_POINTS_NUM];
	Command *gtbCommand[GOALIE_MAX_GTB_POINTS_NUM];

public:
	GoalieIntercept(const WorldModel *worldModel);

	virtual void execute(SayDecisionFlags &sayFlags);
	virtual float getValue();
	virtual DecideType getType();
};

#endif // __GOALIE_INTERCEPT_H
