/*
 *  Copyright 2002-2004, Mersad Team, Allame Helli High School (NODET).
 *
 *  This program is free software, you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU Library General Public License for more details.
 *
 *  Created by: Meisam Vosoughpour
 *  Released on Friday 1 April 2005 by Mersad RoboCup Team.
 *  For more information please read README file.
*/

#ifndef __POSITIONING_H
#define __POSITIONING_H


#include <WorldModel.h>


#define ENSEJAM_MAX_X 2


class Positioning
{
protected:
	float attraction[FULL_PLAYERS_NUM];
	Point ballPos[FULL_PLAYERS_NUM];
	Point basicPos[FULL_PLAYERS_NUM];
	Point playerPos[FULL_PLAYERS_NUM][FULL_PLAYERS_NUM];
	float getMaxXFor34();
	float getMaxXFor7();

	const WorldModel *worldModel;

	void setSimplePos();

public:
	Positioning(const WorldModel *worldModel);

	void setHomePoints();
	Point getHomePoint(unsigned playerUniNum) const;
	Command *getPositioningCommand(Point homePoint) const;

	Point getBasicPos(unsigned num) const;
	Point getOppGoalieKickHome(Point homePoint) const;
};

#endif // __POSITIONING_H
