/*
 *  Copyright 2002-2004, Mersad Team, Allame Helli High School (NODET).
 *
 *  This program is free software, you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU Library General Public License for more details.
 *
 *  Created by: Meisam Vosoughpour
 *  Released on Friday 1 April 2005 by Mersad RoboCup Team.
 *  For more information please read README file.
*/

#ifndef __SRP_DRIBBLE_H
#define __SRP_DRIBBLE_H

#include <AdvancedAction.h>

class SRPDribble: public AdvancedAction
{
protected:
    void getPathValue();
    void getSpeedValue();
    void getNextStatusValue();
    void getDangerFieldValue();
    void getDangerActionValue();
    void getSeeInformationValue();
    void getBreakDefenseLineValue();
	void getOppBallVectorValue();
	void getQuantomicStaminaValue();
	

    Command *srpCommand;

    float sarePaWeight[1000];
    float deltaToFirstTime[1000];
    float nextStatusValue[1000];
    float seeInformationValue[1000];
    float pathValue[1000];
    float speedValue[1000];
    float dangerFieldValue[1000];
	float breakDefenseLineValue[1000];   	
	float oppBallVectorValue[1000];   	
	bool quantomicStaminaValue[1000];
	float sarePaTime[1000];
	float oppGtbTime[1000];
	    
    Point myGoToBallPoint[1000];

    float deltaTimeWeightRate ;
    float nextStatusWeightRate;
    float seeInformationWeightRate;
    float pathWeightRate;
    float speedWeightRate;
    float dangerFieldWeightRate;
	float breakDefenseLineWeightRate;
	float oppBallVectorWeightRate;
    
    int bestSarePaCounter;

public:
	SRPDribble(const WorldModel *worldModel);
	virtual ~SRPDribble();

	virtual void execute(SayDecisionFlags &sayFlags);
	virtual float getValue();
	virtual DecideType getType();
};

#endif // __SRP_DRIBBLE_H
