/*
 *  Copyright 2002-2004, Mersad Team, Allame Helli High School (NODET).
 *
 *  This program is free software, you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU Library General Public License for more details.
 *
 *  Created by: Ahmad Boorghany
 *  Released on Friday 1 April 2005 by Mersad RoboCup Team.
 *  For more information please read README file.
*/

#ifndef __ADVANCED_AGENT_H
#define __ADVANCED_AGENT_H


#include <GroupWorks.h>
#include <Positioning.h>
#include <SyncedAgent.h>
#include <SayDecision.h>
#include <BodyDecision.h>
#include <HeadDecision.h>
#include <PointToDecision.h>
#include <PenaltyDecision.h>
#include <NonPlayOnDecision.h>
#include <GoaliePlayOnDecision.h>
#include <WithBallPlayOnDecision.h>
#include <WithoutBallPlayOnDecision.h>


#ifndef NULL
#	define NULL 0
#endif // NULL


class AdvancedAgent: public SyncedAgent
{
protected:
	Positioning positioning;

	HeadDecision headDecision;
	SayDecision sayDecision;
	PointToDecision pointToDecision;
	GroupWorks groupWorks;

	NonPlayOnDecision nonPlayOnDecision;
	PenaltyDecision penaltyDecision;
	GoaliePlayOnDecision goaliePlayOnDecision;
	WithBallPlayOnDecision withBallPlayOnDecision;
	WithoutBallPlayOnDecision withoutBallPlayOnDecision;

	DecideType curDecide;
	DecideType lastDecide;

	void setAdvancedActions();

	virtual void senseBody(const SExpression &exp);
	virtual void see(const SExpression &exp);
	virtual void hear(const SExpression &exp);

	virtual void sayDecide();
	virtual void headDecide();
	virtual void pointToDecide();
	virtual bool bodyDecide(int QuickLevel);

public:
	AdvancedAgent(int argc, char **argv);
	virtual ~AdvancedAgent();

};


#endif // __ADVANCED_AGENT_H

