/*
 *  Copyright 2002-2004, Mersad Team, Allame Helli High School (NODET).
 *
 *  This program is free software, you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU Library General Public License for more details.
 *
 *  Created by: Mohammad Salehe
 *  Released on Friday 1 April 2005 by Mersad RoboCup Team.
 *  For more information please read README file.
*/

#ifndef __NON_PLAY_ON_DECISION_H
#define __NON_PLAY_ON_DECISION_H


#include <Defines.h>
#include <BodyDecision.h>


class NonPlayOnDecision: public BodyDecision
{
protected:

	// Return Values: 1=not kicker , 2=kicker
	int selectBallKicker(Point positions[11]);
	void selectBallKickerSay(Point positions[11]);
	int savedAdvicePlayer;
	// Return Values: 1=ready to kick , 2=wait
	int backBallChoice(int cyclesToWait = 0);
	void getCurrentHomePoints(Point positions[11]);
	// Return Values: 0=Defense , 1=Offense
	int DefenseOffenseChoice();

public:
	NonPlayOnDecision(const WorldModel *worldModel, const Positioning &positioning,
					SayDecisionFlags &sayFlags, TurnNeckMode &turnNeckMode);
	virtual ~NonPlayOnDecision();

	virtual DecideType decide(int quickLevel);
};


#endif // __NON_PLAY_ON_DECISION_H

