/*
 *  Copyright 2002-2004, Mersad Team, Allame Helli High School (NODET).
 *
 *  This program is free software, you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU Library General Public License for more details.
 *
 *  Created by: Ahmad Boorghany
 *  Released on Friday 1 April 2005 by Mersad RoboCup Team.
 *  For more information please read README file.
*/

#ifndef __SAY_DECISION_H
#define __SAY_DECISION_H


#include <WorldModel.h>


#define RELATED_PLAYER_X_RANGE 47.5
#define RELATED_PLAYER_Y_RANGE 30


struct SayDecisionFlags
{
	bool beforePassSay;
	bool suggestPassSay;
	float passDir;
	float passSpeed;
	float passWeight;
	unsigned interceptNum;
	unsigned attentionNum;
	unsigned passPlayerNum;
	unsigned requestPassSayNum;

	bool freeKickSay;
	int freeKickAdviceNumber;

	SayDecisionFlags();
	void reset();
	void decideReset();
};

class Command;

class SayDecision
{
	const WorldModel *worldModel;
	Command *sayCommand;
	Command *attentionCommand;

	SayDecisionFlags sayFlags;

public:
	SayDecision(const WorldModel *worldModel);
	~SayDecision();

	bool getSayRoutinBallPermission();

	void saySuggestPass();
	void sayBeforePass(const Command *bodyCycleCommand);
	void sayBeforePassRelated(const Command *bodyCycleCommand);
	void sayRoutinBall(const Command *bodyCycleCommand);
	void sayRequestPassSayWithoutBall(const Command *bodyCycleCommand);
	void sayFreeKick();
	void decide(const Command *bodyCycleCommand,
			unsigned gwInterceptNum);

	Command *getSayCommand();
	Command *getAttentionCommand();
	SayDecisionFlags &getSayFlags();

	SayDecisionFlags &setSayFlags();
};

#endif // __SAY_DECISION_H

