/*
 *  Copyright 2002-2004, Mersad Team, Allame Helli High School (NODET).
 *
 *  This program is free software, you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU Library General Public License for more details.
 *
 *  Created by: Mohammad Salehe
 *  Released on Friday 1 April 2005 by Mersad RoboCup Team.
 *  For more information please read README file.
*/

#include <cassert>

#include <Task.h>
#include <iostream>

using namespace std;

// class Task

Task::Task(const CoachWorldModel *worldModel, const CoachWorldModelHistory &worldModelHistory):
	worldModel(worldModel), worldModelHistory(worldModelHistory)
{
}

Task::~Task()
{
}

bool Task::execute()
{
	return true;
}

void Task::setFreeFormSent()
{
	freeFormReadyFlag = false;
	freeFormString = "";
}

void Task::setChangePlayerCommandSent()
{
	hasChangePlayerCommandFlag = false;
	changePlayerCommand = 0;
}
//Getting functions
std::string Task::getFreeFormString()
{
	return freeFormString;
}

bool Task::isFreeFormReady()
{
	return freeFormReadyFlag;
}

Command *Task::getChangePlayerCommand()
{
	return changePlayerCommand;
}

bool Task::hasChangePlayerCommand()
{
	return hasChangePlayerCommandFlag;
}

void Task::informOppChangePlayerType(unsigned playerNum)
{
}

