/*
 *  Copyright 2002-2004, Mersad Team, Allame Helli High School (NODET).
 *
 *  This program is free software, you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU Library General Public License for more details.
 *
 *  Created by: Mohammad Salehe
 *  Released on Friday 1 April 2005 by Mersad RoboCup Team.
 *  For more information please read README file.
*/

#ifndef __TASK_H
#define __TASK_H


#include <BasicCoach.h>
#include <CoachWorldModel.h>


class Task
{
protected:
	const CoachWorldModel *worldModel;
	const CoachWorldModelHistory &worldModelHistory;
	
	std::string freeFormString;
	bool freeFormReadyFlag;
	
	Command *changePlayerCommand;
	bool hasChangePlayerCommandFlag; 

public:
	Task(const CoachWorldModel *worldModel, const CoachWorldModelHistory &worldModelHistory);
	virtual ~Task();
	
	// F:nothing T:done
	virtual bool execute();
	void setFreeFormSent();
	void setChangePlayerCommandSent();
	virtual void informOppChangePlayerType(unsigned playerNum);
	
	// Getting functions
	std::string getFreeFormString();
	bool isFreeFormReady();
	Command *getChangePlayerCommand();
	bool hasChangePlayerCommand();
};


#endif // __TASK_H

