/*
 *  Copyright 2002-2004, Mersad Team, Allame Helli High School (NODET).
 *
 *  This program is free software, you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU Library General Public License for more details.
 *
 *  Created by: Ahmad Boorghany
 *  Released on Friday 1 April 2005 by Mersad RoboCup Team.
 *  For more information please read README file.
*/

#ifndef __VIRTUAL_CONNECTION_H
#define __VIRTUAL_CONNECTION_H

#include <Connection.h>
#include <deque>

#ifndef NULL
#	define NULL 0
#endif // NULL

class VirtualConnection: public Connection
{
protected:
	std::deque<std::string> messages;
	std::string logFileName;

	virtual bool init();

public:
	VirtualConnection();
	virtual ~VirtualConnection();

	void addMessage(const std::string &message);
	virtual void send(const std::string &message);
	virtual int receive(std::string &message);
};

#endif // __VIRTUAL_CONNECTION_H
