/*
 *  Copyright 2002-2004, Mersad Team, Allame Helli High School (NODET).
 *
 *  This program is free software, you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU Library General Public License for more details.
 *
 *  Created by: Mostafa Rokooey
 *  Released on Friday 1 April 2005 by Mersad RoboCup Team.
 *  For more information please read README file.
*/

#ifndef __HALFLINE__H
#define __HALFLINE__H

#include <vector>
#include <Types.h>
#include <Line.h>

class Circle;

class HalfLine
{
protected:
	float a, b, c;
	float m;
	Point sourcePoint;
	float direction;

public:
	float getA(void);
	float getB(void);
	float getC(void);
	Point getSource(void);
	float getDirection(void);

	unsigned getLineIntersect(Line line, Point &intersectPoint);
	unsigned getHalfLineIntersect(HalfLine halfLine, Point &intersectPoint);
	unsigned getCircleIntersect(Circle circle, std::vector<Point> &points);
	float getPointDist(Point point);
	bool checkPoint(Point point);

	void setByABC(float inpA, float inpB, float inpC);
	void setByPointDir(Point point, float Dir);
};

#endif // __HALFLINE_H
