/*
 *  Copyright 2002-2004, Mersad Team, Allame Helli High School (NODET).
 *
 *  This program is free software, you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU Library General Public License for more details.
 *
 *  Created by: Ahmad Boorghany
 *  Modified by: Mohammad Salehe
 *  Released on Friday 1 April 2005 by Mersad RoboCup Team.
 *  For more information please read README file.
*/

#include <Basics.h>
#include <math.h>
#include <stdio.h>
#include <string.h>

using namespace std;

namespace Basics
{
	float reRate(float value, float a, float b, float c,
			float d, ReRateMode mode)
	{
		if (a == b)
			return c;

		if (mode == RRM_DIRECT)
		{
			if (value < a)
				return c;
			if (value > b)
				return d;
			return (value - a) / (b - a) * (d - c) + c;
		}
		else
		{
			if (value < a)
				return d;
			if (value > b)
				return c;
			return (value - a) / (b - a) * (c - d) + d;
		}
	}

	float sigmoid(float x)
	{
		return (float)(1 / (1 + exp(-x)));
	}

	unsigned changeIntBase(int number, int base, string &str)
	{
		unsigned i = 0;

		for (i = 0; number > base; i++)
		{
			str += (char)(number % base);
			number = (int)((float)number / base);
		}

		str += (char)number;
		return i + 1;
	}
}
