/*
 *  Copyright 2002-2004, Mersad Team, Allame Helli High School (NODET).
 *
 *  This program is free software, you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU Library General Public License for more details.
 *
 *  Created by: Ahmad Boorghany
 *  Released on Friday 1 April 2005 by Mersad RoboCup Team.
 *  For more information please read README file.
*/

#ifndef __SAY_ENCODING_H
#define __SAY_ENCODING_H

#include <string>

#ifndef NULL
#	define NULL 0
#endif // NULL

class SayEncoding
{
public:
	SayEncoding();

	static std::string sayCodeKey;

	static unsigned getCharNum(char ch);

	static void encodeObjectPosition(float x, float y, std::string &code);
	static void decodeObjectPosition(const std::string &code,
			unsigned codePtr, float &x, float &y);
	static void encodeObjectVelocity(float magnitude, float direction, 
			std::string &code);
	static void decodeObjectVelocity(const std::string &code,
			unsigned codePtr, float &magnitude, float &direction);
	static void encodeWeight(float weight, float start,
			float end, std::string &code);
	static void decodeWeight(const std::string &code,
			unsigned codePtr, float &weight, float start, float end);
};

#endif // __SAY_ENCODING_H

