/*
 *  Copyright 2002-2004, Mersad Team, Allame Helli High School (NODET).
 *
 *  This program is free software, you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU Library General Public License for more details.
 *
 *  Created by: Ahmad Boorghany
 *  Released on Friday 1 April 2005 by Mersad RoboCup Team.
 *  For more information please read README file.
*/

#include <cmath>

#include <Types.h>


using namespace std;


ostream &operator<<(ostream &stream, const Point &point)
{
	stream << "(" << point.x << "," << point.y << ")";
	return stream;
}

ostream &operator<<(ostream &stream, const BallStatus &var)
{
	switch (var)
	{
	case BS_NONE:
		stream << "BS_NONE";
		break;

	case BS_KICKABLE_TMM:
		stream << "BS_KICKABLE_TMM";
		break;

	case BS_KICKABLE_OPP:
		stream << "BS_KICKABLE_OPP";
		break;

	case BS_KICKABLE_BODY:
		stream << "BS_KICKABLE_BODY";
		break;

	case BS_KICKABLE_BODY_TMM:
		stream << "BS_KICKABLE_BODY_TMM";
		break;

	case BS_KICKABLE_BODY_OPP:
		stream << "BS_KICKABLE_BODY_OPP";
		break;

	case BS_KICKABLE_TMM_OPP:
		stream << "BS_KICKABLE_TMM_OPP";
		break;

	case BS_FREE_BALL:
		stream << "BS_FreeBall";
		break;

	case BS_FREE_BALL_TMM:
		stream << "BS_FREE_BALL_TMM";
		break;

	case BS_FREE_BALL_OPP:
		stream << "BS_FREE_BALL_OPP";
		break;

	case BS_FREE_BALL_BODY:
		stream << "BS_FREE_BALL_BODY";
		break;

	case BS_FREE_BALL_TMM_OPP:
		stream << "BS_FREE_BALL_TMM_OPP";
		break;

	case BS_FREE_BALL_BODY_TMM:
		stream << "BS_FREE_BALL_BODY_TMM";
		break;

	case BS_FREE_BALL_BODY_OPP:
		stream << "BS_FREE_BALL_BODY_OPP";
		break;

	}

	return stream;
}

float Point::getDistance(const Point &point)
{
	return hypot(x - point.x, y - point.y);
}

